/*
 *  Hello World for the CodeWarrior
 *   1997-1998 Metrowerks Corp.
 *
 *  Questions and comments to:
 *       <mailto:support@metrowerks.com>
 *       <http://www.metrowerks.com/>
 */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include <StandardFile.h>
#include <Finder.h>
#include "EvenMoreFiles.h"

int main(void)
{
	StandardFileReply	sfReply;
	// Printf to initialize toolbox
	printf ("Hi\n");
	fflush (stdout);
	
	for (;;) {
		StandardGetFile (nil, -1, nil, &sfReply);
		if (sfReply.sfGood) {
			FInfo				fndrInfo;
			ExtendedFileInfo	fndrXInfo;
			OSErr				err;

			err = FSpGetFInfo (&sfReply.sfFile, &fndrInfo);
			if (err != noErr) {
				printf ("FSpGetFInfo returned %d\n", err);
			} else {
				printf ("kIsAlias                     : %d\n",
					(fndrInfo.fdFlags & kIsAlias) >> 15);
				printf ("kIsInvisible                 : %d\n",
					(fndrInfo.fdFlags & kIsInvisible) >> 14);
				printf ("kHasBundle                   : %d\n",
					(fndrInfo.fdFlags & kHasBundle) >> 13);
				printf ("kNameLocked                  : %d\n",
					(fndrInfo.fdFlags & kNameLocked) >> 12);
				printf ("kIsStationery                : %d\n",
					(fndrInfo.fdFlags & kIsStationery) >> 11);
				printf ("kHasCustomIcon               : %d\n",
					(fndrInfo.fdFlags & kHasCustomIcon) >> 10);
				printf ("reserved (0x0200)            : %d\n",
					(fndrInfo.fdFlags & 0x0200) >> 9);
				printf ("kHasBeenInited               : %d\n",
					(fndrInfo.fdFlags & kHasBeenInited) >> 8);
				printf ("kHasNoINITs                  : %d\n",
					(fndrInfo.fdFlags & kHasNoINITs) >> 7);
				printf ("kIsShared                    : %d\n",
					(fndrInfo.fdFlags & kIsShared) >> 6);
				printf ("reserved (0x0030)            : %d\n",
					(fndrInfo.fdFlags & 0x0030) >> 4);
				printf ("kColor                       : %d\n",
					(fndrInfo.fdFlags & kColor) >> 1);
				printf ("kIsOnDesk                    : %d\n",
					fndrInfo.fdFlags & kIsOnDesk);
			}


			err = FSpGetExtendedFileInfo (&sfReply.sfFile, &fndrXInfo);
			if (err != noErr) {
				printf ("FSpGetExtendedFileInfo returned %d\n", err);
			} else {
				printf ("kExtendedFlagsAreInvalid     : %d\n",
					(fndrXInfo.extendedFinderFlags & kExtendedFlagsAreInvalid) >> 15);
				printf ("reserved (0x7E00)            : %d\n",
					(fndrXInfo.extendedFinderFlags & 0x7E00) >> 9);
				printf ("kExtendedFlagHasCustomBadge  : %d\n",
					(fndrXInfo.extendedFinderFlags & kExtendedFlagHasCustomBadge) >> 8);
				printf ("reserved (0x00F8)            : %d\n",
					(fndrXInfo.extendedFinderFlags & 0x00F8) >> 3);
				printf ("kExtendedFlagHasRoutingInfo  : %d\n",
					(fndrXInfo.extendedFinderFlags & kExtendedFlagHasRoutingInfo) >> 2);
				printf ("reserved (0x0003)            : %d\n",
					fndrXInfo.extendedFinderFlags & 0003);
			}
		}

		{
			char c;
			fflush (stdin);
			printf ("Hit enter to continue.\n");
			scanf ("%c", &c);
		}
	}

	return 0;
}

